.686
.MMX

.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   Include masm32.inc
   include fMath.inc
   include fFile.inc
   Include Grafik_Test2.inc
   include GUI.inc
   
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
onTimer proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
onTimer2 proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
onTimer3 proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM


Main_Program proto hWnd:dword,mDC:dword
CheckUntilSetMode proto :dword,:dword
MainGraphics proto :dword,:dword,:dword,:dword
Graphics2 proto hWnd:dword,hDC:dword,hBmp:dword,lpn:dword
ButtonCheck proto :dword,:dword
ButtonCheck2 proto :dword,:Dword
DrawButton proto hWnd:dword,mDC:dword

CUSM_s1 proto :dword,:dword
ThreadProc proto :dword

FEQ Struct
	id dword 0
	nBit dword 0
FEQ ends

.data
   ClassName db "TFEQ",0
   AppName  db "Farabi Alquran x-2.0",0
	f fDC <>
	
	setting_data db "DataSetting.frb",0
	fa db "map_index.bmp",0
	
	FontStruc	LOGFONT <-13,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,DRAFT_QUALITY,DEFAULT_PITCH+FF_SWISS,'Arial '>

.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	gMem dword ?
   
	case dword ?
	frame dword ?
	btn_hlgt dword ?
	hlm dword ?
	the_z dword ?
   
	ap FEQ <?>
	m POINT <?>

	ThreadID DWORD ?
	mg dword ?
	g_buff dword ?  
	g_deg dword ?
	
	fps dword ?
	ms dword ?
	
	btn0 fbtn <?>
   	btn1 fbtn <?>
	
	hFont dword ?
.code


; ---------------------------------------------------------------------------


start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	LOCAL  hwnd:HWND 
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hDC:dword
	
	.IF uMsg==WM_DESTROY
		push f.nBit
		pop ap.nBit
;		invoke Tutup,addr ap,addr setting_data,addr frame,8
		
		invoke LocalUnlock,gMem
		invoke LocalFree,gMem
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		; Main Function
		invoke LocalAlloc,LMEM_DISCARDABLE,(1024*768*4)*4
		mov gMem,eax
		
		; Todo: Your Initialization here
;		invoke Buka,addr ap,addr setting_data,addr frame,8
;		mov ap.id,'TFEQ'
		
		mov case,1
		mov frame,1
		mov the_z,0
		
		push ap.nBit
		pop f.nBit
		
		.if f.nBit==0
			mov f.nBit,32
		.endif
		
		push esi
			mov esi,gMem
			lea eax,[esi+1024*768*4*2]
			mov g_buff,eax
		pop esi
	
	invoke Phase1
	
	invoke SetTimer,hWnd,1,(1000/20),offset onTimer
	invoke SetTimer,hWnd,2,1000,offset onTimer2
	invoke SetTimer,hWnd,3,(1000/25),offset onTimer3
	
	invoke CreateFontIndirect,addr FontStruc
	mov hFont,eax
	
	
	.elseif uMsg==WM_MOUSEMOVE
		mov eax,lParam
		mov ecx,eax
		and eax,0FFFFh
		mov m.x,eax
		
		shr ecx,16
		mov m.y,ecx
		
	
	.elseif uMsg==WM_LBUTTONUP
	;	mov  eax,OFFSET ThreadProc
	;	invoke CreateThread,NULL,200,eax,NULL,NORMAL_PRIORITY_CLASS,ADDR ThreadID
	;	invoke CloseHandle,eax
		invoke GetDC,hWnd
 			mov hDC,eax 
 			invoke Main_Program,hWnd,hDC
 		invoke ReleaseDC,hWnd,hDC
	.elseif uMsg==WM_RBUTTONUP
		mov case,1
		.if f.nBit==16
		;	mov f.nBit,32
		.elseif f.nBit==32
		;	mov f.nBit,16
		.endif 
			
	.elseif uMsg==0
		.if wParam==4
			invoke PostQuitMessage,NULL
		.endif
;	.elseif uMsg==WM_PAINT
	;		invoke GetDC,hWnd
 	;		mov hDC,eax 
 	;		invoke Main_Program,hWnd,hDC
 	;		invoke ReleaseDC,hWnd,hDC
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


onTimer2 proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hDC:dword
	
	push mg
	pop fps
	mov mg,0
	
	ret
onTimer2 endp


onTimer proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hDC:dword
	LOCAL ps:PAINTSTRUCT
	
	
	
	invoke GetCurrentProcess
	invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS

	invoke GetTickCount
	push eax
	
	invoke GetDC,hWnd
 	mov hDC,eax 
 	invoke Main_Program,hWnd,hDC
 	invoke ReleaseDC,hWnd,hDC
	
	
	invoke GetTickCount
	pop ecx
	sub eax,ecx
	mov ms,eax

	invoke GetCurrentProcess
	invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS
	
	ret
onTimer endp

Main_Program proc uses esi hWnd:Dword, hDC:dword 
	LOCAL mDC:dword,hBmp:dword,hOld:dword 
	LOCAL r:RECT 
	LOCAL Text[1024]:dword 
	LOCAL posX,posY,clr,xc,yc,xc2,yc2,xc3,yc3,xc4,yc4,co:dword 
	LOCAL g:wBMP
	LOCAL bih:BITMAPINFOHEADER
	LOCAL pbm:dword
	
	
	invoke CreateCompatibleDC,hDC
	mov mDC,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,r.right
	mov f.MaxX,eax
	mov eax,r.bottom
	mov f.MaxY,eax	
	
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDC,addr bih,DIB_RGB_COLORS,addr pbm,0,0
	mov hBmp,eax
		
	invoke SelectObject,mDC,hBmp 
	mov hOld,eax
	invoke SelectObject,mDC,hFont
	
	
;	mov eax,pbm
	mov eax,gMem
	mov f.lpBits,eax
	
;	invoke GetStockObject,BLACK_BRUSH
;	invoke FillRect,mDC,addr r,eax 
	invoke SetBkMode,mDC,TRANSPARENT 
	invoke SetTextColor,mDC,0FF00h 
	; Todo: Sub_main_Function here.
	; 	
	

	
	cmp case,0
	jle @f
	push case
	pop frame
	
	cmp case,1
	jz case_1
	ret
	case_1:
	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,1
	mul ecx
	add eax,gMem
	push f.lpBits
		mov f.lpBits,eax
		invoke MainGraphics,hWnd,mDC,hBmp,addr f 
	pop f.lpBits
	mov case,0
	case_2:
	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,1
	mul ecx
	add eax,gMem
	push f.lpBits
		mov f.lpBits,eax
		
	pop f.lpBits
	mov case,0
	case_3:
	
	case_4:
	
	case_5:
	@@:
	
	cmp frame,0
	jle @f
	cmp frame,1
	jz frame_1
	ret
	frame_1:
	invoke ButtonCheck,m.x,m.y
	invoke ButtonCheck2,m.x,m.y
	invoke DrawButton,hWnd,mDC
	@@:
	
	cmp btn_hlgt,1
	jz btn_hlgt_1
	cmp btn_hlgt,2
	jz btn_hlgt_2
	cmp btn_hlgt,3
	jz btn_hlgt_3
	jmp @f
	btn_hlgt_1:
		invoke CreatePixel16,255,255,255,f.nBit
		invoke RectMod,addr f,130,10,450,350,eax,0
		jmp @f
	btn_hlgt_2:
		invoke CreatePixel16,128,128,128,f.nBit	
		invoke fButton,addr f,130,10,450,350,eax
	;	invoke fDrawButton,addr f,addr btn1,150,10
		jmp @f
	btn_hlgt_3:
		invoke fLoadBitMap,addr fa,addr f,NULL,130,10
	btn_hlgt_4:
	
	@@:

	invoke CreatePixel16,128,128,128,f.nBit		
	invoke fScrollBar,addr f,560,10,20,350,1,100,eax

	
	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,0
	mul ecx
	add eax,gMem

	invoke SetBitmapBits,hBmp,800*600*4,eax
;	invoke SetDIBitsToDevice,mDC,0,0,f.MaxX,f.MaxY,0,0,0,f.MaxY,f.lpBits,addr bih,DIB_RGB_COLORS
	
	
	; End of sub_main_function
	
	
;	invoke CountFPS,mDC,g_buff,fps
	
;	invoke dw2a,the_z,addr Text
;	invoke TextOut,mDC,150,30,addr Text,eax
	
;	invoke dw2a,ms,addr Text
;	invoke TextOut,mDC,150,45,addr Text,eax

;	invoke dw2a,g_deg,addr Text
;	invoke TextOut,mDC,150,60,addr Text,eax
	
;	invoke dw2a,btn0.lpptr,addr Text
;	invoke TextOut,mDC,130,30,addr Text,eax
	
	
	
	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,1
	mul ecx
	add eax,gMem	
	invoke fCopyMemory,f.lpBits,eax,1024*768*4
	
	
	invoke BitBlt,hDC,0,0,r.right,r.bottom,mDC,0,0,SRCCOPY 

	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,2
	mul ecx
	add eax,gMem	
	invoke GetBitmapBits,hBmp,800*600*4,eax
	
	invoke DeleteDC,mDC 
	invoke DeleteObject,hBmp
		
	inc mg
	
	;invoke KillTimer,hWnd,1
	
	ret
Main_Program endp

onTimer3 proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL mDC:dword,hBmp:dword,hOld:dword 
	LOCAL r:RECT 
	LOCAL Text[1024]:dword 
	LOCAL posX,posY,clr,xc,yc,xc2,yc2,xc3,yc3,xc4,yc4,co:dword 
	LOCAL g:wBMP
	LOCAL bih:BITMAPINFOHEADER
	LOCAL pbm:dword
	LOCAL hDC:dword
	
	invoke GetDC,hWnd
 	mov hDC,eax 
	
	invoke CreateCompatibleDC,hDC
	mov mDC,eax
	invoke GetClientRect,hWnd,addr r 
	mov eax,r.right
	mov f.MaxX,eax
	mov eax,r.bottom
	mov f.MaxY,eax	
	
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push 1024
	pop bih.biWidth
	push 768
	pop bih.biHeight
	mov bih.biPlanes,1
	mov bih.biBitCount,32
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,mDC,addr bih,DIB_RGB_COLORS,addr pbm,0,0
	mov hBmp,eax
		
	invoke SelectObject,mDC,hBmp 
	mov hOld,eax

	
	xor edx,edx
	mov eax,(1024*768*4)
	mov ecx,2
	mul ecx
	add eax,gMem
	mov f.lpBits,eax
	
	invoke SetBkMode,mDC,TRANSPARENT 
	invoke SetTextColor,mDC,0FF00h 
	; Todo: Sub_main_Function here.
	; 	
;	xor edx,edx
;	mov eax,(1024*768*4)
;	mov ecx,2
;	mul ecx
;	add eax,gMem	
;	invoke fCopyMemory,f.lpBits,eax,1024*500*4
		

	invoke SetBitmapBits,hBmp,800*600*4,f.lpBits
	invoke BitBlt,hDC,0,0,r.right,r.bottom,mDC,0,0,SRCCOPY 
	invoke DeleteDC,mDC 
	invoke DeleteObject,hBmp
	
	invoke ReleaseDC,hWnd,hDC	
	
	cmp mg,5
	jl @f
		invoke KillTimer,hWnd,1
	@@:
	
	ret
onTimer3 endp

MainGraphics proc uses esi hWnd:dword,hDC:dword,hBmp:dword,lpn:dword
	LOCAL a:fDC
	LOCAL Text[256]:byte
	LOCAL w:warna
	LOCAL xc,yc,co:dword
	LOCAL g:wBMP
	
	mov esi,lpn
	push [esi]
	pop a.lpBits
	push [esi+4]
	pop a.MaxX
	push [esi+8]
	pop a.MaxY
	push [esi+12]
	pop a.nBit
	

	invoke CreatePixel16,128,128,0,a.nBit
	invoke fButton,addr a,-1,-1,a.MaxX,a.MaxY,eax
	
	
	invoke CreatePixel16,128,128,128,a.nBit
	invoke fButton,addr a,5,10,115,355,eax
	
;	invoke CreatePixel16,0,128,0,a.nBit
;	invoke fButton,addr a,130,10,450,355,eax
	
	mov yc,10
	loop_b:
	invoke CreatePixel16,128,128,128,a.nBit
	push eax
		mov eax,35
		mul yc
		xchg eax,edx
	pop eax
	sub edx,20
	invoke fButton,addr a ,10,edx,105,30,eax
	dec yc
	jnz loop_b
	
	invoke CreatePixel16,0,128,128,a.nBit
	invoke fButton,addr a,5,370,575,50,eax
	
	mov yc,12
	@@:
	invoke CreatePixel16,128,128,0,a.nBit
	push eax
		mov eax,35
		mul yc
		xchg eax,edx
	pop eax
	sub edx,10	
	invoke fButton,addr a,edx,380,30,30,eax	
;	invoke fCircleGrad,addr a,edx,395,20,eax

	dec yc
	jnz @b

	invoke CreatePixel16,128,0,0,a.nBit
	invoke fCircleGrad,addr a,300,150,100,eax
	
	
	invoke CreatePixel16,128,0,0,a.nBit	
	invoke fCreateButton,addr a,addr btn0,10,10,105,30,eax
	
	invoke CreatePixel16,128,0,0,a.nBit	
	invoke fCreateSphere,addr a,addr btn1,10,10,100,eax
	
	ret
MainGraphics endp

Graphics2 proc uses esi hWnd:dword,hDC:dword,hBmp:dword,lpn:dword
	
	
	@@:
	
	sub the_z,100
	cmp the_z,-11000
	jns @f
		mov the_z,10001
	@@:
	
;	invoke CreatePixel16,255,0,0,f.nBit
;	invoke Rect3D,addr f,150,-300,the_z,100,100,100,eax
;	invoke CreatePixel16,255,0,0,f.nBit
;	invoke Rect3D,addr f,150,-400,the_z,100,100,100,eax
	
	
	
;	mov ecx,10
;	mov edx,500
;	push the_z
;	@@:
;	push ecx
;		push edx
;			invoke CreatePixel16,255,0,0,f.nBit
;		pop edx
;		push edx
;			invoke Rect3D,addr f,150,edx,the_z,100,100,100,eax
;			add the_z,200
;		pop edx
;	pop ecx
;	sub edx,100
;	jnz @b
;	mov edx,500
;	sub ecx,1
;	jnz @b
;	pop the_z
;	
;	mov ecx,10
;	mov edx,500
;	push the_z
;	@@:
;	push ecx
;		push edx
;			invoke CreatePixel16,255,0,0,f.nBit
;		pop edx
;		push edx
;			invoke Rect3D,addr f,-150,edx,the_z,100,100,100,eax
;			add the_z,200
;		pop edx
;	pop ecx
;	sub edx,100
;	jnz @b
;	mov edx,500
;	sub ecx,1
;	jnz @b
;	pop the_z
	
	mov ecx,10
	mov edx,500
	push the_z
	@@:
	push ecx
		push edx
			invoke CreatePixel16,255,0,0,f.nBit
		pop edx
		push edx
			neg edx
			invoke Rect3D,addr f,-150,edx,the_z,100,100,100,eax
			add the_z,200
		pop edx
	pop ecx
	sub edx,100
	jnz @b
	mov edx,500
	sub ecx,1
	jnz @b
	pop the_z
	
	

	
	ret
Graphics2 endp

DrawButton proc hWnd:dword,hDC:Dword
	LOCAL yc:dword
	
	cmp btn_hlgt,10
	ja @f
	cmp btn_hlgt,0
	jle @f
		mov eax,btn_hlgt
		mov ecx,35
		mul ecx
		xchg eax,ecx
		push ecx
	;		invoke CreatePixel16,128,0,0,f.nBit
		pop ecx
		sub ecx,20
	;	invoke fButton,addr f,10,ecx,105,30,eax
		invoke fDrawButton,addr f,addr btn0,10,ecx

	@@:
	
	cmp hlm,0
	jle @f
	invoke CreatePixel16,128,0,0,f.nBit
	push eax
		mov eax,35
		mul hlm
		xchg eax,edx
	pop eax
	sub edx,10	
	invoke fButton,addr f,edx,380,30,30,eax
;	invoke fCircleGrad,addr f,edx,395,20,eax

	@@:
	
	
	ret
DrawButton endp

ButtonCheck proc x:dword,y:dword
	LOCAL yc:dword
	
	mov yc,10
	xor ecx,ecx
	loop_b:
		inc ecx
		push ecx
		mov eax,35
		mul ecx
		sub eax,20
			invoke IsInsideRect,x,y,10,eax,105,30
		pop ecx
		cmp al,1
		jz found
	dec yc
	jnz loop_b
	
	ret
	found:
		mov btn_hlgt,ecx
	ret
ButtonCheck endp

ButtonCheck2 proc x:dword,y:dword
	LOCAL yc:dword
	
	mov yc,12
	xor ecx,ecx
	loop_b:
		inc ecx
		push ecx
		mov eax,35
		mul ecx
		sub eax,10
			invoke IsInsideRect,x,y,eax,380,30,30
		pop ecx
		cmp al,1
		jz found
	dec yc
	jnz loop_b
	ret
	
	found:
		mov hlm,ecx
	ret
ButtonCheck2 endp

ThreadProc proc param:dword
	LOCAL hDC:dword

	
;	invoke GetDC,hwnd
 ;	mov hDC,eax 
 ;	invoke Main_Program,hwnd,hDC
 ;	invoke ReleaseDC,hwnd,hDC
 ;	
;	invoke PostQuitMessage,NULL
;	movq mm0,[esi]
	
	ret
ThreadProc endp

end start
